找回密码
 立即注册

QQ登录

只需一步,快速开始

微信扫码登录

搜索
楼主: 2847657989

[分享] 讲一个UGCAM二次开发中创建操作的函数写法

 火... [复制链接]

1

主题

98

回帖

739

积分

四级士官

积分
739
发表于 2017-3-19 02:43:54 | 显示全部楼层
阿斯蒂芬拉开技术的;弗兰克加强;为搂去玩儿欠妥

0

主题

29

回帖

339

积分

二级士官

积分
339
发表于 2017-3-23 23:04:25 | 显示全部楼层
#include <stdio.h>#include <uf.h>#include <uf_ui.h>#include <uf_disp.h>#include<uf_modl.h>#include<uf_layer.h>#include<uf_assem.h>#include<uf_obj.h>#include<uf_part.h>#include<iostream>#define UF_CALL(X) (report( __FILE__, __LINE__, #X, (X)))static int report( char *file, int line, char *call, int irc){  if (irc)  {     char    messg[133];     printf("%s, line %d:  %s\n", file, line, call);     (UF_get_fail_message(irc, messg)) ?       printf("    returned a %d\n", irc) :       printf("    returned error %d:  %s\n", irc, messg);  }  return(irc);}static void do_ugopen_api(void){     UF_FEATURE_SIGN sign = UF_NULLSIGN;     tag_t target = NULL_TAG;     double origin [] = {0.0,0.0,0.0};     char* height = "100";     char* cyl_diam = "80";     double cyl_direction [] = {0.0,0.0,1.0};     tag_t cyl_feat_tag = NULL_TAG;     UF_MODL_create_cylinder(sign,target,origin,height,cyl_diam,cyl_direction,&cyl_feat_tag);     double value;     tag_t target1;     UF_MODL_create_exp_tag(height,&target1);//Creates a parameter expression, based upon the input string.     UF_MODL_ask_exp_tag_value(target1,&value);//Asks the value of an expression tag.     double location[3]={0.0,0.0,0.0} ;      double direction [] = {0.0,0.0,1.0};     tag_t obj=null_tag;     char *diam="30";     char *angle="0";     tag_t bottom,top;     tag_t feature_obj_id ;     uf_list_p_t face_list;     UF_MODL_create_list(&face_list);//Retrieves an object from a linked list of objects     UF_MODL_ask_feat_faces(cyl_feat_tag,&face_list);     int count=0;     UF_MODL_ask_list_count(face_list,&count);//Retrieves the count from a linked list of objectsfor(int i=0;i<count;i++){     UF_MODL_ask_list_item(face_list,i,&obj);     int type;     double point [3] ;     double dir [3] ;     double box [6] ;     double radius;     double  rad_data;     int  norm_dir ;     UF_MODL_ask_face_data(obj,&type,point,dir,box,&radius,&rad_data,&norm_dir);//Queries the data associated with a face     if(type==22)//“22”代表有界平面     {         if(fabs(point[2]-origin[2])<0.0005)         {             bottom=obj;         }         if(fabs(point[2]-value)<0.0001)         {             UF_MODL_ask_feat_location(obj,location);             top=obj;         }     }}UF_MODL_create_simple_hole(location,direction,diam,height,angle,top,bottom,&feature_obj_id);UF_MODL_ask_feat_faces(feature_obj_id,&face_list);UF_MODL_ask_list_count(face_list,&count);for(int i=0;i<count;i++){     UF_MODL_ask_list_item(face_list,i,&obj);//Retrieves an object from a linked list of objects   int typel;     UF_MODL_ask_face_type(obj,&typel);     //倒圆角     if(typel== UF_MODL_CYLINDRICAL_FACE )     {         uf_list_p_t facesl;         UF_MODL_create_list(&facesl);         UF_MODL_ask_shared_edges(top,obj,&facesl);         const char * radius="3";         int smooth_overflow=0;         int cliff_overflow=0;         int notch_overflow=0;         double vrb_tool=3;         tag_t feature_obj_idl;         UF_MODL_create_blend(radius, facesl, smooth_overflow, cliff_overflow, notch_overflow, vrb_tool, &feature_obj_id );      }   }}void ufusr(char *param, int *retcode, int param_len){  if (!UF_CALL(UF_initialize()))  {    do_ugopen_api();    UF_CALL(UF_terminate());  }}int ufusr_ask_unload(void){  return (UF_UNLOAD_IMMEDIATELY);}

0

主题

1

回帖

20

积分

列兵

积分
20
发表于 2017-3-25 11:26:20 | 显示全部楼层
很好的一段,正好解决了心中的一些疑惑

0

主题

439

回帖

7441

积分

少校

积分
7441
发表于 2017-3-28 03:21:52 | 显示全部楼层
看一下思路如何

0

主题

282

回帖

1090

积分

六级士官

积分
1090
发表于 2017-3-30 13:40:43 | 显示全部楼层
看一下思路如何

1

主题

30

回帖

379

积分

二级士官

积分
379
发表于 2017-4-6 16:12:47 | 显示全部楼层
看一下思路如何

9

主题

70

回帖

921

积分

五级士官

积分
921
发表于 2017-4-7 11:35:37 | 显示全部楼层
这个貌似不太好学啊

0

主题

82

回帖

844

积分

四级士官

积分
844
发表于 2017-4-27 11:11:49 | 显示全部楼层
感谢分享

2

主题

40

回帖

574

积分

三级士官

积分
574
发表于 2017-4-28 11:31:00 | 显示全部楼层
~~~~~~~~~~~~~~~~~~~~~~~~~

0

主题

670

回帖

6845

积分

上尉

积分
6845
发表于 2017-4-29 14:56:14 | 显示全部楼层
nuz4
您需要登录后才可以回帖 登录 | 立即注册

本版积分规则

咨询QQ:1359218528|发帖须知!|Archiver|手机版|小黑屋|UG爱好者论坛 ( 京ICP备10217105号-2 )

GMT+8, 2024-12-23 20:40

Powered by Discuz! X3.5

© 2001-2024 Discuz! Team.

快速回复 返回顶部 返回列表